package org.grails.maven.plugin;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on grails-maven-plugin.<br/> Call <pre>  mvn grails:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Dec 10 14:42:44 CET 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.7)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.grails:grails-maven-plugin:2.1.2", 0 );
        append( sb, "", 0 );

        append( sb, "Maven plugin for GRAILS applications", 0 );
        append( sb, "This plugin allows you to integrate GRAILS applications into maven 2 builds.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 37 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "clean".equals( goal ) )
        {
            append( sb, "grails:clean", 0 );
            append( sb, "Cleans a Grails project.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "config-directories".equals( goal ) )
        {
            append( sb, "grails:config-directories", 0 );
            append( sb, "Set sources/tests directories to be compatible with the directories layout used by grails.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "console".equals( goal ) )
        {
            append( sb, "grails:console", 0 );
            append( sb, "Runs a Grails console inside the current project.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-controller".equals( goal ) )
        {
            append( sb, "grails:create-controller", 0 );
            append( sb, "Creates a new controller.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "controllerName", 2 );
                append( sb, "The name for the controller to create.", 3 );
                append( sb, "Expression: ${controllerName}", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-domain-class".equals( goal ) )
        {
            append( sb, "grails:create-domain-class", 0 );
            append( sb, "Creates a new domain class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "domainClassName", 2 );
                append( sb, "The name for the domain class to create.", 3 );
                append( sb, "Expression: ${domainClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-integration-test".equals( goal ) )
        {
            append( sb, "grails:create-integration-test", 0 );
            append( sb, "Creates a new Grails integration test which loads the whole Grails environment when run.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "integrationTestName", 2 );
                append( sb, "The name for the unit test to create.", 3 );
                append( sb, "Expression: ${integrationTestName}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-pom".equals( goal ) )
        {
            append( sb, "grails:create-pom", 0 );
            append( sb, "Creates a creates a maven 2 POM for an existing Grails project.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "groupId", 2 );
                append( sb, "The Group Id of the project to be build.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${groupId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-script".equals( goal ) )
        {
            append( sb, "grails:create-script", 0 );
            append( sb, "Creates a Grails Gant Script.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "scriptName", 2 );
                append( sb, "The name for the script to create.", 3 );
                append( sb, "Expression: ${scriptName}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-service".equals( goal ) )
        {
            append( sb, "grails:create-service", 0 );
            append( sb, "Creates a new service class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "serviceName", 2 );
                append( sb, "The name for the service to create.", 3 );
                append( sb, "Expression: ${serviceName}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-tag-lib".equals( goal ) )
        {
            append( sb, "grails:create-tag-lib", 0 );
            append( sb, "Creates a new GSP tag library.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );

                append( sb, "tagLibName", 2 );
                append( sb, "The name for the taglib to create.", 3 );
                append( sb, "Expression: ${tagLibName}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "create-unit-test".equals( goal ) )
        {
            append( sb, "grails:create-unit-test", 0 );
            append( sb, "Creates a new Grails unit test. A unit test requires that you mock out access to dynamic methods, but executes a lot quicker.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );

                append( sb, "unitTestName", 2 );
                append( sb, "The name for the unit test to create.", 3 );
                append( sb, "Expression: ${unitTestName}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "exec".equals( goal ) )
        {
            append( sb, "grails:exec", 0 );
            append( sb, "Executes an arbitrary Grails command.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "args", 2 );
                append( sb, "Set this to the arguments you want to pass to the command.", 3 );
                append( sb, "Expression: ${args}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "command", 2 );
                append( sb, "Set this to name of the command you want to execute.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${command}", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-all".equals( goal ) )
        {
            append( sb, "grails:generate-all", 0 );
            append( sb, "Generates a CRUD interface (controller + views) for a domain class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "domainClassName", 2 );
                append( sb, "The name of the domain class to generate the CRUD interface.", 3 );
                append( sb, "Expression: ${domainClass}", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-controller".equals( goal ) )
        {
            append( sb, "grails:generate-controller", 0 );
            append( sb, "Generates a CRUD controller for a specified domain class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "domainClassName", 2 );
                append( sb, "The name of the domain class to generate the CRUD controller.", 3 );
                append( sb, "Expression: ${domainClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-views".equals( goal ) )
        {
            append( sb, "grails:generate-views", 0 );
            append( sb, "Generates the CRUD views for a specified domain class.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "domainClassName", 2 );
                append( sb, "The name of the domain class to generate the CRUD views.", 3 );
                append( sb, "Expression: ${domainClass}", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "grails:help", 0 );
            append( sb, "Display help information on grails-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0grails:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "init".equals( goal ) )
        {
            append( sb, "grails:init", 0 );
            append( sb, "Validate consistency between Grails and Maven settings.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "init-plugin".equals( goal ) )
        {
            append( sb, "grails:init-plugin", 0 );
            append( sb, "Validate consistency between Grails and Maven settings.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "install-templates".equals( goal ) )
        {
            append( sb, "grails:install-templates", 0 );
            append( sb, "Installs the artifact and scaffolding templates.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "list-plugins".equals( goal ) )
        {
            append( sb, "grails:list-plugins", 0 );
            append( sb, "Lists the available plugins.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "maven-clean".equals( goal ) )
        {
            append( sb, "grails:maven-clean", 0 );
            append( sb, "Cleans a Grails project and jars in lib directory.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "maven-compile".equals( goal ) )
        {
            append( sb, "grails:maven-compile", 0 );
            append( sb, "Compiles a Grails project.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "maven-functional-test".equals( goal ) )
        {
            append( sb, "grails:maven-functional-test", 0 );
            append( sb, "Runs a Grails application\'s functional tests.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "mavenSkip", 2 );
                append( sb, "Set this to \'true\' to bypass functional tests entirely. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${maven.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );

                append( sb, "skip", 2 );
                append( sb, "Set this to \'true\' to bypass functional tests entirely. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${grails.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass functional tests entirely. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );

                append( sb, "testFailureIgnore (Default: false)", 2 );
                append( sb, "Set this to \'true\' to ignore a failure during testing. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${maven.test.failure.ignore}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "maven-grails-app-war".equals( goal ) )
        {
            append( sb, "grails:maven-grails-app-war", 0 );
            append( sb, "Creates a WAR archive and register it in maven. This differs from the MvnWarMojo in that it makes the WAR file the build artifact for the \'grails-app\' packaging. The standard \'maven-war\' goal is designed for the normal \'war\' packaging.\n\nSo why have two versions? Well, version 1.0 of the plugin was released with the war packaging as the default for Grails projects. That hasn\'t worked out so well, but we still need to support it, so we need one war target for the war packaging type, and one for the grails-app packaging type (which is now preferred over war).\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "maven-test".equals( goal ) )
        {
            append( sb, "grails:maven-test", 0 );
            append( sb, "Runs a Grails applications unit tests and integration tests.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "mavenSkip", 2 );
                append( sb, "Set this to \'true\' to bypass unit/integration tests entirely. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${maven.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );

                append( sb, "skip", 2 );
                append( sb, "Set this to \'true\' to bypass unit/integration tests entirely. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${grails.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass unit/integration tests entirely. Its use is", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );

                append( sb, "testFailureIgnore (Default: false)", 2 );
                append( sb, "Set this to \'true\' to ignore a failure during testing. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${maven.test.failure.ignore}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "maven-war".equals( goal ) )
        {
            append( sb, "grails:maven-war", 0 );
            append( sb, "Creates a WAR archive for the project and puts it in the usual Maven place.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package".equals( goal ) )
        {
            append( sb, "grails:package", 0 );
            append( sb, "Packages the Grails application into the web-app folder for running.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package-plugin".equals( goal ) )
        {
            append( sb, "grails:package-plugin", 0 );
            append( sb, "Packages the Grails plugin.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run-app".equals( goal ) )
        {
            append( sb, "grails:run-app", 0 );
            append( sb, "Runs a Grails application in Jetty.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run-app-https".equals( goal ) )
        {
            append( sb, "grails:run-app-https", 0 );
            append( sb, "Runs a Grails application in Jetty with HTTPS listener.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run-war".equals( goal ) )
        {
            append( sb, "grails:run-war", 0 );
            append( sb, "Runs a Grails application in Jetty from its WAR.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "set-version".equals( goal ) )
        {
            append( sb, "grails:set-version", 0 );
            append( sb, "Set the grails application version from the Maven POM version.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test-app".equals( goal ) )
        {
            append( sb, "grails:test-app", 0 );
            append( sb, "Runs a Grails applications unit tests and integration tests.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );

                append( sb, "testPatterns", 2 );
                append( sb, "The space-separated list of test classes to run (e.g. *Controller)", 3 );
                append( sb, "Expression: ${testPatterns}", 3 );
                append( sb, "", 0 );

                append( sb, "testTypesAndPhases", 2 );
                append( sb, "The space-separated list of test types or phases (e.g unit: :spock)", 3 );
                append( sb, "Expression: ${testTypesAndPhases}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "upgrade".equals( goal ) )
        {
            append( sb, "grails:upgrade", 0 );
            append( sb, "Upgrades a Grails application to the version of this plugin.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate".equals( goal ) )
        {
            append( sb, "grails:validate", 0 );
            append( sb, "Validate consistency between Grails and Maven settings.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-plugin".equals( goal ) )
        {
            append( sb, "grails:validate-plugin", 0 );
            append( sb, "Validate consistency between Grails and Maven settings.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "war".equals( goal ) )
        {
            append( sb, "grails:war", 0 );
            append( sb, "Creates a WAR archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "activateAgent", 2 );
                append( sb, "Whether to activate the reloading agent (forked mode only) for this command", 3 );
                append( sb, "Expression: ${activateAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "basedir (Default: ${basedir})", 2 );
                append( sb, "The directory where is launched the mvn command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "env", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${grails.env}", 3 );
                append( sb, "", 0 );

                append( sb, "extraClasspathEntries", 2 );
                append( sb, "Extra classpath entries as a comma separated list of file names. For entries with a comma in their name, use backslash to escape. INTERNAL This parameter is not meant to be used externally. It is used by IDEs that require extra classpath entries to execute grails commands.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${fork}", 3 );
                append( sb, "", 0 );

                append( sb, "forkDebug (Default: false)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkDebug}", 3 );
                append( sb, "", 0 );

                append( sb, "forkedVmArgs", 2 );
                append( sb, "List of arguments passed to the forked VM", 3 );
                append( sb, "", 0 );

                append( sb, "forkMaxMemory (Default: 1024)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMaxMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkMinMemory (Default: 512)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkMinMemory}", 3 );
                append( sb, "", 0 );

                append( sb, "forkPermGen (Default: 256)", 2 );
                append( sb, "Whether the JVM is forked for executing Grails commands", 3 );
                append( sb, "Expression: ${forkPermGen}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsBuildListener", 2 );
                append( sb, "Fully qualified classname of a grails build listener to attach to the Grails command", 3 );
                append( sb, "", 0 );

                append( sb, "grailsEnv", 2 );
                append( sb, "The Grails environment to use.", 3 );
                append( sb, "Expression: ${environment}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsHome", 2 );
                append( sb, "The path to the Grails installation.", 3 );
                append( sb, "Expression: ${grailsHome}", 3 );
                append( sb, "", 0 );

                append( sb, "grailsWorkDir (Default: ${project.build.directory}/work)", 2 );
                append( sb, "The Grails work directory to use.", 3 );
                append( sb, "Expression: ${grails.grailsWorkDir}", 3 );
                append( sb, "", 0 );

                append( sb, "nonInteractive (Default: false)", 2 );
                append( sb, "Whether to run Grails in non-interactive mode or not. The default is to run interactively, just like the Grails command-line.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nonInteractive}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginsDir (Default: ${basedir}/plugins)", 2 );
                append( sb, "The directory where plugins are stored.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${pluginsDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showStacktrace (Default: false)", 2 );
                append( sb, "Turns on/off stacktraces in the console output for Grails commands.", 3 );
                append( sb, "Expression: ${showStacktrace}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
